- [HTTP request](https://developers.google.com/search-ads/reporting/api/reference/rest/v0/customers.searchAds360/search#body.HTTP_TEMPLATE)
- [Path parameters](https://developers.google.com/search-ads/reporting/api/reference/rest/v0/customers.searchAds360/search#body.PATH_PARAMETERS)
- [Request body](https://developers.google.com/search-ads/reporting/api/reference/rest/v0/customers.searchAds360/search#body.request_body)
  - [JSON representation](https://developers.google.com/search-ads/reporting/api/reference/rest/v0/customers.searchAds360/search#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://developers.google.com/search-ads/reporting/api/reference/rest/v0/customers.searchAds360/search#body.response_body)
  - [JSON representation](https://developers.google.com/search-ads/reporting/api/reference/rest/v0/customers.searchAds360/search#body.SearchSearchAds360Response.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://developers.google.com/search-ads/reporting/api/reference/rest/v0/customers.searchAds360/search#body.aspect)

Returns all rows that match the search query.

List of thrown errors: [AuthenticationError]() [AuthorizationError]() [ChangeEventError]() [ChangeStatusError]() [ClickViewError]() [HeaderError]() [InternalError]() [QueryError]() [QuotaError]() [RequestError]()

### HTTP request

`POST https://searchads360.googleapis.com/v0/customers/{customerId}/searchAds360:search`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `customerId` | `string` Required. The ID of the customer being queried. |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "query": string, "pageToken": string, "pageSize": integer, "validateOnly": boolean, "returnTotalResultsCount": boolean, "summaryRowSetting": enum (`https://developers.google.com/search-ads/reporting/api/reference/rest/v0/SummaryRowSetting`) } ``` |

| Fields ||
|---|---|
| `query` | `string` Required. The query string. |
| `pageToken` | `string` Token of the page to retrieve. If not specified, the first page of results will be returned. Use the value obtained from `nextPageToken` in the previous response in order to request the next page of results. |
| `pageSize` | `integer` Number of elements to retrieve in a single page. When too large a page is requested, the server may decide to further limit the number of returned resources. |
| `validateOnly` | `boolean` If true, the request is validated but not executed. |
| `returnTotalResultsCount` | `boolean` If true, the total number of results that match the query ignoring the LIMIT clause will be included in the response. Default is false. |
| `summaryRowSetting` | ``enum (`https://developers.google.com/search-ads/reporting/api/reference/rest/v0/SummaryRowSetting`)`` Determines whether a summary row will be returned. By default, summary row is not returned. If requested, the summary row will be sent in a response by itself after all other query results are returned. |

### Response body

Response message for `https://developers.google.com/search-ads/reporting/api/reference/rest/v0/customers.searchAds360/search#google.ads.searchads360.v0.services.SearchAds360Service.Search`.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "results": [ { object (`https://developers.google.com/search-ads/reporting/api/reference/rest/v0/SearchAds360Row`) } ], "nextPageToken": string, "totalResultsCount": string, "fieldMask": string, "summaryRow": { object (`https://developers.google.com/search-ads/reporting/api/reference/rest/v0/SearchAds360Row`) }, "customColumnHeaders": [ { object (`https://developers.google.com/search-ads/reporting/api/reference/rest/v0/CustomColumnHeader`) } ], "conversionCustomMetricHeaders": [ { object (`https://developers.google.com/search-ads/reporting/api/reference/rest/v0/ConversionCustomMetricHeader`) } ], "conversionCustomDimensionHeaders": [ { object (`https://developers.google.com/search-ads/reporting/api/reference/rest/v0/ConversionCustomDimensionHeader`) } ], "rawEventConversionMetricHeaders": [ { object (`https://developers.google.com/search-ads/reporting/api/reference/rest/v0/RawEventConversionMetricHeader`) } ], "rawEventConversionDimensionHeaders": [ { object (`https://developers.google.com/search-ads/reporting/api/reference/rest/v0/RawEventConversionDimensionHeader`) } ] } ``` |

| Fields ||
|---|---|
| `results[]` | ``object (`https://developers.google.com/search-ads/reporting/api/reference/rest/v0/SearchAds360Row`)`` The list of rows that matched the query. |
| `nextPageToken` | `string` Pagination token used to retrieve the next page of results. Pass the content of this string as the `pageToken` attribute of the next request. `nextPageToken` is not returned for the last page. |
| `totalResultsCount` | `string (https://developers.google.com/discovery/v1/type-format format)` Total number of results that match the query ignoring the LIMIT clause. |
| `fieldMask` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#field-mask` format)`` FieldMask that represents what fields were requested by the user. This is a comma-separated list of fully qualified names of fields. Example: `"user.displayName,photo"`. |
| `summaryRow` | ``object (`https://developers.google.com/search-ads/reporting/api/reference/rest/v0/SearchAds360Row`)`` Summary row that contains summary of metrics in results. Summary of metrics means aggregation of metrics across all results, here aggregation could be sum, average, rate, etc. |
| `customColumnHeaders[]` | ``object (`https://developers.google.com/search-ads/reporting/api/reference/rest/v0/CustomColumnHeader`)`` The headers of the custom columns in the results. |
| `conversionCustomMetricHeaders[]` | ``object (`https://developers.google.com/search-ads/reporting/api/reference/rest/v0/ConversionCustomMetricHeader`)`` The headers of the conversion custom metrics in the results. |
| `conversionCustomDimensionHeaders[]` | ``object (`https://developers.google.com/search-ads/reporting/api/reference/rest/v0/ConversionCustomDimensionHeader`)`` The headers of the conversion custom dimensions in the results. |
| `rawEventConversionMetricHeaders[]` | ``object (`https://developers.google.com/search-ads/reporting/api/reference/rest/v0/RawEventConversionMetricHeader`)`` The headers of the raw event conversion metrics in the results. |
| `rawEventConversionDimensionHeaders[]` | ``object (`https://developers.google.com/search-ads/reporting/api/reference/rest/v0/RawEventConversionDimensionHeader`)`` The headers of the raw event conversion dimensions in the results. |

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/doubleclicksearch`